-- Copyright 2006 Emanuele Lecchi
-- Editing and abuse of this script is encouraged, as long as the original author (me) remains mentioned.
-- Thankyou and enjoy!
--===================================================================================================--
-- Edited installer to support max 2014 [removed ['s] in lele's vray tool which can cause menu to dissapear after max reboot ]
-- Remove some file installer to make it simple in installer [still kept the original scheme tho !!]
-- Now you can drag and drop installer to viewport without getting error when installing process begin
-- Last thank to Emanuele Lecchi for his original script


global instRoll
global leleGetMacrosDir
global myScriptPath= getFilenamePath (getSourceFileName())
global myTilte="Lele's V-Ray Tools"

installableArray=#(#("Anything_To_Phys_Cam_Max_9\\MaxCam_To_PhysCam_1.4_proc.mse"),#("Light_Monkey_Max_9\\lightMonkey_0.3_proc.mse"),
						#("Matrix_Exposimeter_Max_9\\Matrix_exposimeter_1.21_proc.mse"),#("New_PPT_Calc_Max_9\\NEW_VRay_PPT_Calc_proc.mse"),
						#("Physcam_Auto-Focus_Max_9\\PhysCam_AF_proc.mse"),#("PhysCam_Param_Cloner_Max_9\\PhysCam_Param_Copier_Proc.mse","PhysCam_Param_Cloner_Max_9\\PhysCam_Param_Paster_Proc.mse"),
						#("PhysCam_Presets_Deck_Max_9\\PhysCam_Presets_Proc.mse"),#("Realtime_Sky_Max_9\\realtime_sky_proc.mse"),
						#("Stuff_Collector_Max_9\\collector_proc.mse"),#("VRay_RenderTime_Infos_Max_9\\vray_render_info_destroyer_proc.ms","VRay_RenderTime_Infos_Max_9\\vray_render_info_proc.ms"))
	
oldInstallableArray=#("MaxCam_To_PhysCam_proc.mse","MaxCam_To_PhysCam.ms","MaxCam_To_PhysCam_1.1_proc.mse",
							  "MaxCam_To_PhysCam_1.2_proc.mse","MaxCam_To_PhysCam_1.4_proc.mse","Lele_s VRay Tools-MaxCam_2_PhysCam.mcr","Lele_s VRay Tools-MaxCam_2_PhysCam.mcr" ,
							  "lightMonkey_0.3_proc.mse","matrix_exposimeter_1.0_proc.mse",
							  "matrix_exposimeter_1.1_proc.mse","matrix_exposimeter_1.12_proc.mse","matrix_exposimeter_1.13_proc.mse",
							  "matrix_exposimeter_1.14_proc.mse","matrix_exposimeter_1.15_proc.mse","matrix_exposimeter_1.16_proc.mse",
							  "matrix_exposimeter_1.17_proc.mse","matrix_exposimeter_1.18_proc.mse","matrix_exposimeter_1.21_proc.mse","NEW_VRay_PPT_Calc_proc.mse",
							  "PhysCam_AF_proc.mse","PhysCam_Param_Copier_Proc.mse","PhysCam_Param_Paster_Proc.mse",
							  "PhysCam_Param_Paster_Proc.mse","realtime_sky_proc.mse","collector_proc.mse","vray_render_info_proc.ms",
							  "vray_render_info_destroyer_proc.ms","vray_render_info_proc.mse","vray_render_info_destroyer_proc.mse")


fn leleGetMacrosDir=
(
	if (maxVersion())[1] >=16000 then return (getDir #maxroot) else return (getDir #UI)
)

fn leleInstall theScript = --the script = array
(
	UIPath= leleGetMacrosDir()
		
	for k in theScript do
	(
	scriptName=pathConfig.stripPathToLeaf k
	thisScript= (myScriptPath+k)
	installedScript=(UIPath+"MacroScripts"+"\\"+ scriptName)
	installerScript=(getFilenamePath thisScript)+"installer.ms"
	format "Installed Script : %\n" scriptName
	if (getFileSize installedScript) != (getFileSize thisScript) do
		(
			if (deleteFile installedScript) then 
				(
					copyFile thisScript installedScript
					filein installerScript
				) 
			else
				(
					renameFile installedScript "*.old"
					copyFile thisScript installedScript
					filein installerScript
				)
		)
	)
)

fn checkChecks = 
	(
	local notAll=false
	for i=1 to 10 do 
	(
		if instRoll.controls[i].checked == false do notAll=true
	)
	if notAll then (instRoll.controls[11].checked=false) else (instRoll.controls[11].checked=true)
)

fn versionReader = 
(
	verFiles=#()
	theFolders=getDirectories (myScriptPath + ".\*")
	theVersions=#()
	
	if thefolders.count != 0 do
	(
		for i=1 to theFolders.count do 
		(
			verFiles[i] =theFolders[i] + "version" 
			tempFile=openFile verFiles[i] mode:"r"
			theVersions[i]=readline tempFile
			flush tempFile
			close tempFile
		)
		
		for i=1 to theVersions.count do 
		(
			instRoll.controls[23+i].caption = theVersions[i] as string
			--execute ("instRoll.lbl"+i as string+".caption=theVersions["+i as string+"] as string")
		)
	)
)

fn oldFilesCleaner = 
(
	theUIPath=leleGetMacrosDir()
	maxV=(maxversion())[1]
		
	if maxV >= 9000 then
		(
			theoldfiles = getFiles ((getDir #userMacros)+"\\"+"Lele*")
			for i in theOldFiles do 
				(
					if doesFileExist i do
					(
						format "Cleaned this file : %\n" i
						deletefile i
					)
				)
			for j in oldInstallableArray do 
				(
				theFile2Clean= (theUIPath+"MacroScripts"+"\\"+j)
					if doesFileExist theFile2Clean do
					(	
					format "Cleaned this file : %\n" j
					deleteFile theFile2Clean
					)
				)	
		)
	else
		(
			messageBox "Deep deletion isn't necessery !" title:myTilte
		)
)

fn addToQuad = 
(
	--menuMan.unRegisterQuadMenu quadMenu
	
	try (quadMenu = menuMan.createQuadMenu "Lele VRay Tools" "Lele VRay Tools" "quad2Name" "quad3Name" "quad4Name"
	menu = quadMenu.getMenu 1) catch()
	
		
	try (testItem = menuMan.createActionItem "Matrix_Exposimeter" "Lele VRay Tools"
	menu.addItem testItem -1) catch()
	try (testItem = menuMan.createActionItem "LC_PPT_Calculator" "Lele VRay Tools"
	menu.addItem testItem -1) catch()
	try (testItem = menuMan.createActionItem "PhysCam_Auto_Focus" "Lele VRay Tools"
	menu.addItem testItem -1) catch()
	try (testItem = menuMan.createActionItem "Physcam_Converter" "Lele VRay Tools"
	menu.addItem testItem -1) catch()
	try (testItem = menuMan.createActionItem "Realtime_Sky" "Lele VRay Tools"
	menu.addItem testItem -1) catch()
	try (testItem = menuMan.createActionItem "VRay_Light_Monkey" "Lele VRay Tools"
	menu.addItem testItem -1) catch()
	try (testItem = menuMan.createActionItem "VRay_Stuff_Collector" "Lele VRay Tools"
	menu.addItem testItem -1) catch()
	try (testItem = menuMan.createActionItem "VRay_RenderTime_Infos_Activator" "Lele VRay Tools"
	menu.addItem testItem -1) catch()
	try (testItem = menuMan.createActionItem "VRay_RenderTime_Infos_DeActivator" "Lele VRay Tools"
	menu.addItem testItem -1) catch()
	try (testItem = menuMan.createActionItem "PhysCam_Parameters_Copier" "Lele VRay Tools"
	menu.addItem testItem -1) catch()
	try (testItem = menuMan.createActionItem "PhysCam_Parameters_Paster" "Lele VRay Tools"
	menu.addItem testItem -1) catch()
	try (testItem = menuMan.createActionItem "PhysCam_Presets_Deck" "Lele VRay Tools"
	menu.addItem testItem -1) catch()

	try(menuMan.setViewportRightClickMenu #shiftAndAltAndControlPressed quadmenu
	menuMan.getQuadMenuName quadmenu) catch()
	)

try (destroyDialog instRoll) catch()
rollout instRoll "Lele's VRay Script Pack Installer" width:256 height:348
(
	
	checkbox chk1 "Physcam Converter" pos:[16,32] width:160 height:16 checked:true
	checkbox chk2 "VRay Light Monkey" pos:[16,56] width:160 height:16 checked:true
	checkbox chk3 "Matrix Exposimeter" pos:[16,80] width:160 height:16 checked:true
	checkbox chk4 "LC/PPT Calculator" pos:[16,104] width:160 height:16 checked:true
	checkbox chk5 "Physcam Auto-Focus" pos:[16,128] width:160 height:16 checked:true
	checkbox chk6 "Physcam Parameters Cloner" pos:[16,152] width:160 height:16 checked:true
	checkbox chk7 "Physcam Presets Deck" pos:[16,176] width:160 height:16 checked:true
	checkbox chk8 "VRay Realtime Sky" pos:[16,200] width:160 height:16 checked:true
	checkbox chk9 "VRay Stuff Collector" pos:[16,224] width:160 height:16 checked:true
	checkbox chk10 "VRay Rendertime Infos" pos:[16,248] width:160 height:16 checked:true
	checkbox chk11 "Install Them All" pos:[16,280] width:96 height:16 checked:true
	GroupBox grp1 "Choose Scripts to Install:" pos:[8,8] width:240 height:264
	button btnZ "Install them!" pos:[8,320] width:240 height:25 toolTip:"Install Selected Scripts!"
	button btn1 "?" pos:[224,32] width:16 height:16 toolTip:"What does this script do?"
	button btn2 "?" pos:[224,56] width:16 height:16 toolTip:"What does this script do?"
	button btn3 "?" pos:[224,80] width:16 height:16 toolTip:"What does this script do?"
	button btn4 "?" pos:[224,104] width:16 height:16 toolTip:"What does this script do?"
	button btn5 "?" pos:[224,128] width:16 height:16 toolTip:"What does this script do?"
	button btn6 "?" pos:[224,152] width:16 height:16 toolTip:"What does this script do?"
	button btn7 "?" pos:[224,176] width:16 height:16 toolTip:"What does this script do?"
	button btn8 "?" pos:[224,200] width:16 height:16 toolTip:"What does this script do?"
	button btn9 "?" pos:[224,224] width:16 height:16 toolTip:"What does this script do?"
	button btn10 "?" pos:[224,248] width:16 height:16 toolTip:"What does this script do?"
	label lbl1 "" pos:[176,32] width:40 height:16
	label lbl2 "" pos:[176,56] width:40 height:16
	label lbl3 "" pos:[176,80] width:40 height:16
	label lbl4 "" pos:[176,104] width:40 height:16
	label lbl5 "" pos:[176,128] width:40 height:16
	label lbl6 "" pos:[176,152] width:40 height:16
	label lbl7 "" pos:[176,176] width:40 height:16
	label lbl8 "" pos:[176,200] width:40 height:16
	label lbl9 "" pos:[176,224] width:40 height:16	
	label lbl10 "" pos:[176,248] width:40 height:16
	checkbox chk12 "Deep Delete Old Ones" pos:[120,280] width:128 height:16 checked:true
	checkbox chk13 "Add To Ctrl+Alt+Shift Quadmenu" pos:[16,304] width:192 height:16 checked:true
	
	on instRoll open do
	(
		versionReader()
		if (maxversion())[1] <9000 then chk12.enabled=false else chk12.enabled=true
		clearlistener()
	)
	
	on instRoll close do
	(
		if globalVars.isglobal #instRoll do globalVars.remove #instRoll
		if globalVars.isglobal #leleGetMacrosDir do globalVars.remove #leleGetMacrosDir	
		if globalVars.isglobal #myScriptPath do globalVars.remove #myScriptPath
		if globalVars.isglobal #myTilte do globalVars.remove #myTilte		
	)
	
	on chk1 changed state do
	(
		checkChecks()
		)
	on chk2 changed state do
	(
		checkChecks()
		)
	on chk3 changed state do
	(
		checkChecks()
		)
	on chk4 changed state do
	(
		checkChecks()
		)
	on chk5 changed state do
	(
		checkChecks()
		)
	on chk6 changed state do
	(
		checkChecks()
		)
	on chk7 changed state do
	(
		checkChecks()
		)
	on chk8 changed state do
	(
		checkChecks()
		)
	on chk9 changed state do
	(
		checkChecks()
		)
	on chk10 changed state do
	(
		checkChecks()
		)
	on chk11 changed state do
	(
		for i=1 to 10 do (
		instRoll.controls[i].checked = state
		)
	)
	on btnZ pressed do
	(
			if chk12.checked do (
				if (queryBox "Warning! This will delete ALL the old scripts and macros from the max folders. \nMake sure you are reinstalling all the ones you need!\n Select \"Yes\" to deep-delete files, or \"No\" to skip deep deletion." title:"Remove ALL the old Pack MacrosScripts?") do ( 
					oldFilesCleaner()
				)
			)
			installedOnes=#()	
			
			for i=1 to 10 do 
				(
 				if instRoll.controls[i].checked	do 
 					(
					leleInstall installableArray[i]	
					append installedOnes instRoll.controls[i].caption	
					)
				)
				
			if installedOnes.count !=0 then 
				(
				theString="All done, you just installed :\n\n"
				if chk13.checked do addToQuad()	
				for s in installedOnes do (
					theString+=("-->  "+s+"\n")
					)
				theString+="\nYou'll find the new commands under\n\"Customize->Customize User Interface...->MainUI->Lele's VRay Tools\"\nFrom there, you can assign each tool to a shortcut,\n a quad menu, standard Max menus or toolbars."
				
				if chk13.checked then
					(
						theString+="\nYou'll find the new commands under\n\"Customize->Customize User Interface...->MainUI->Lele's VRay Tools\"\nFrom there, you can assign each tool to a shortcut,\n a quad menu, standard Max menus or toolbars."
						theString+="\nYou have chosen to automaticaly create a new quadMenu for the scripts;\npress Ctrl+Alt+Shift and then the right mouse button to call up the Quad"
					) 
				else 
					(
					theString+="\nYou'll find the new commands under\n\"Customize->Customize User Interface...->MainUI->Lele's VRay Tools\"\nFrom there, you can assign each tool to a shortcut,\n a quad menu, standard Max menus or toolbars."
					)
				destroyDialog instRoll
				messageBox theString title:myTilte
				) else (messageBox "Please select at least ONE script to install, or I am entirely useless!")
			)
	on btn1 pressed do
	(
		messageBox "This script converts a standard max camera (with its animated FoV, in case it's present)\nor a max viewport (perspective, orthogonal, camera) into a VRay Physcal Camera,\n trying to preserve all the important parameters." title:myTilte
		)
	on btn2 pressed do
	(
		messageBox "This script allows for a simple way to mass change VRay Lights Properties. \nSelect some, change the parameters in the script interface, and click the S button by the parameter(s) to change only the selected lights \n or press the A button by the parameter(s) to change all the VRay lights in the scene." title:myTilte
		)
	on btn3 pressed do
	(
		messageBox "This script opens the Matrix Exposimeter panel: \na fully-fledged tool to expose VRay Physical cameras \nwhich is based on the same principles of\ncurrent dSLR Matrix-Weigthed Exposimeters" title:myTilte
		)
	on btn4 pressed do
	(
		messageBox "This script is a calculator able to express LC/PPT sample sizes in Pixels, \nrather than percentage of the image,and shading rates instead of subdivisions" title:myTilte
		)
	on btn5 pressed do
	(
		messageBox "This script allows for multiple Physical Cameras to focus on the closest object\nor on a user-picked object (when in front of the camera)." title:myTilte
		)
	on btn6 pressed do
	(
		messageBox "This script installs two interface-less commands:\nA parameter Copier, and a parameter Paster.\nAssign them to shortcuts, select one (or more) \nPhysical cameras, run the copier.\nSelect one (or as many as before) cameras, run the paster:\n your parameters have been copied across." title:myTilte
		)
	on btn7 pressed do
	(
		messageBox "This script creates a 12-slots preset deck\nto store Physical cameras settings,\neven across Max sessions.\nImmediate in its usage, and visually more controllable." title:myTilte
		)
	on btn8 pressed do
	(
		messageBox "The script enables the Realtime Update of the VRaySky map in Viewport\nEnable the Background display for one or more views, \nand leave any sky parameter to whatever your standard workflow requires.\nThe script will make modifications which will NOT change the way the sky will render, \nand that will be reverted as soon as the script is closed, or the realtime update deactivated." title:myTilte
		)

	on btn9 pressed do
	(
		messageBox "The script collects VRay specific items \n(proxies, VRayHDRI maps, maps stored in the render panel \nenvironment overrides, and so on)\n along with standard max bitmaps and the scene itself.\nOptionally, the collected scene can be opened as current, \nand the paths may or may not be changed to reflect the collection." title:myTilte
		)
	on btn10 pressed do
	(
		messageBox "This script is composed of two commands: \none to Activate the infos, another to turn them off \n(restarting max has the same effect, by the way). \nWhen the infos are active, a dialog box will pop up \nduring rendering to show some useful infos about your scene, \nso to make it easier to troubleshoot it if it renders for too long, \nwithout stopping the rendering." title:myTilte
		)
)

createDialog instRoll